/*
 * Copyright (c) 2004-2007 Erez Zadok
 * Copyright (c) 2004-2007 Stony Brook University
 * Copyright (c) 2004-2007 The Research Foundation of State University of New York
 * Copyright (c) 2004-2007 Nikolai Joukov
 *
 * For specific licensing information, see the COPYING file distributed with
 * this package, or get one from ftp://ftp.filesystems.org/pub/fist/COPYING.
 *
 * This Copyright notice must be kept intact and distributed with all
 * fistgen sources INCLUDING sources generated by fistgen.
 */

#ifndef __HASH_LIST_H
#define __HASH_LIST_H

#include <stdlib.h>
#include "hash.h"

typedef struct list_entry_s list_entry_t;

typedef struct hash_list_s {
  hash_t hash;
  list_entry_t* list_head;
  list_entry_t* list_tail;
  int list_size;
} hash_list_t;


//Public Functions
int hash_list_init(hash_list_t* hash_list,int hash_size);
inline int hash_list_get_size(hash_list_t* hash_list);
//Adds to the list
inline int hash_list_add(hash_list_t* hash_list,void* key,int keylen,void* value);
int hash_list_add_first(hash_list_t* hash_list,void* key,int keylen,void* value);
int hash_list_add_last(hash_list_t* hash_list,void* key,int keylen,void* value);
void* hash_list_remove(hash_list_t* hash_list,void* key,int keylen); //returns Null on fail
void* hash_list_remove_first(hash_list_t* hash_list); //Returns and removes the first element
void* hash_list_remove_last(hash_list_t* hash_list); //Returns and removes the last element
void* hash_list_remove_location(hash_list_t* hash_list,int loc);
void* hash_list_get_first(hash_list_t* hash_list); //Returns the first element
void* hash_list_get_last(hash_list_t* hash_list); //Returns the last element
void* hash_list_get_location(hash_list_t* hash_list,int loc);
void* hash_list_find(hash_list_t* hash_list,void* key,int keylen);
int hash_list_destroy(hash_list_t* hash_list);

#endif //#ifndef __HASH_LIST_H
